;-------------------------------------------------
;Steuert die WABECO CNC-Frsmaschine an
;-------------------------------------------------

;	Code for the best assembler: The Netwide Assembler: NASM
;	Copyright (C) 2004 by Sebastian Beck; sebastian.bw@freenet.de

;	Wenn Sie eine Spende machen wollen, fragen Sie mich ber E-Mail
;	nach meinem Konto.

;	If you want to make a donation, please question me by e-mail for
;	my banking connection.

;-------------------------------------------------
;%include "./INC/outnc2.6.inc"
;-------------------------------------------------
;Bewegung		db	0
;
;		Z	Y	X				Bewegung
;	-------------------------------------------------------------------------------
;	1-	00	00	01	-X nach rechts
;	2-	00	00	10	+X nach links
;	4-	00	01	00				-Y nach hinten
;	5-	00	01	01	-X nach rechts	-Y nach hinten
;	6-	00	01	10	+X nach links	-Y nach hinten
;	8-	00	10	00				+Y nach vorne
;	9-	00	10	01	-X nach rechts	+Y nach vorne
;	10-	00	10	10	+X nach links	+Y nach vorne
;	16-	01	00	00							+Z nach oben
;	17-	01	00	01	-X nach rechts				+Z nach oben
;	18-	01	00	10	+X nach links				+Z nach oben
;	20-	01	01	00				-Y nach hinten	+Z nach oben
;	21-	01	01	01	-X nach rechts	-Y nach hinten	+Z nach oben
;	22-	01	01	10	+X nach links	-Y nach hinten	+Z nach oben
;	24-	01	10	00				+Y nach vorne	+Z nach oben
;	25-	01	10	01	-X nach rechts	+Y nach vorne	+Z nach oben
;	26-	01	10	10	+X nach links	+Y nach vorne	+Z nach oben
;	32-	10	00	00							-Z nach unten
;	33-	10	00	01	-X nach rechts				-Z nach unten
;	34-	10	00	10	+X nach links				-Z nach unten
;	36-	10	01	00				-Y nach hinten	-Z nach unten
;	37-	10	01	01	-X nach rechts	-Y nach hinten	-Z nach unten
;	38-	10	01	10	+X nach links	-Y nach hinten	-Z nach unten
;	40-	10	10	00				+Y nach vorne	-Z nach unten
;	41-	10	10	01	-X nach rechts	+Y nach vorne	-Z nach unten
;	42-	10	10	10	+X nach links	+Y nach vorne	-Z nach unten


;Delay		dd	0		;in Millisekunden
;X			dd	0		;Werkstck-X-Position
;Y			dd	0		;Werkstck-Y-Position
;Z			dd	0		;Werkstck-Z-Position
;Spielx		db	0		;Spiel der X-Achse
;Spiely		db	0		;Spiel der Y-Achse
;Spielz		db	0		;Spiel der Z-Achse - fr Rundtisch

;-------------------------------------------------

outnc:
section .data

.save		db	0			;fr die Steuerung (out)
.richtung	db	00010101b		;fr's Spiel
.achsex	db	127			;Achsausgleich X
.achsey	db	127			;Achsausgleich Y
.achsez	db	127			;Achsausgleich Z

section .text
	pushad
	mov	dx,$37A

	mov	bl,[Bewegung]	;neu
	mov	al,[.richtung]	;alt
	
	xor	al,bl
	and	bl,al
	mov	al,[.save]
	mov	ah,[.richtung]
	
	test	bl,00000001b	;ist X jetzt nach rechts?
	jz	.w15			;nein
	
	mov	ecx,0			;X war nach links und ist jetzt nach rechts
	and	ah,11111100b
	or	ah,00000001b	;richtung aktuallisieren
	mov	cl,[Spielx]
	cmp	cl,0
	jz	.w30			;X hat kein Spiel -> Y
	
.w5:					;------------------------
	test	al,2
	jz	.w10			
	xor	al,2
	out	dx,al
	call	.tout
.w10:
	xor	al,2
	or	al,1
	out	dx,al
	call	.tout
	loop	.w5			;------------------------
	jmp	.w30			;nach Y
	
	
.w15:
	test	bl,00000010b	;ist X jetzt nach links?
	jz	.w30			;nein
	
	mov	ecx,0			;X war nach rechts und ist jetzt nach links
	and	ah,11111100b
	or	ah,00000010b	;richtung aktuallisieren
	mov	cl,[Spielx]
	cmp	cl,0
	jz	.w30			;X hat kein Spiel -> Y
	
.w20:					;------------------------
	test	al,2
	jz	.w25			
	xor	al,2
	out	dx,al
	call	.tout
.w25:
	xor	al,2
	and	al,11111110b
	out	dx,al
	call	.tout
	loop	.w20			;------------------------
	
	
.w30:		
	test	bl,00000100b	;ist Y jetzt nach hinten?
	jz	.w45			;nein
	
	mov	ecx,0			;Y war nach vorne und ist jetzt nach hinten
	and	ah,11110011b
	or	ah,00000100b	;richtung aktuallisieren
	mov	cl,[Spiely]
	cmp	cl,0
	jz	.w60			;Y hat kein Spiel -> Z
	
.w35:					;------------------------
	test	al,4
	jnz	.w40
	xor	al,4
	out	dx,al
	call	.tout
.w40:
	xor	al,4
	or	al,1
	out	dx,al
	call	.tout
	loop	.w35			;------------------------
	jmp	.w60			;nach Z
	
	
.w45:
	test	bl,00001000b	;ist Y jetzt nach vorne?
	jz	.w60			;nein
	
	mov	ecx,0			;ja - Y war nach hinten und ist jetzt nach vorne
	and	ah,11110011b
	or	ah,00001000b	;richtung aktuallisieren
	mov	cl,[Spiely]
	cmp	cl,0
	jz	.w60			;Y hat kein Spiel -> Z
	
.w50:					;------------------------
	test	al,4
	jnz	.w55
	xor	al,4
	out	dx,al
	call	.tout
.w55:
	and	al,11111110b
	xor	al,4
	out	dx,al
	call	.tout
	loop	.w50

.w60:
	test	bl,00010000b	;ist Z jetzt nach oben?
	jz	.w75			;nein
	
	mov	ecx,0			;ja - Z war nach unten und ist jetzt nach oben
	and	ah,11001111b
	or	ah,00010000b	;richtung aktuallisieren
	mov	cl,[Spielz]
	cmp	cl,0
	jz	.w89			;Z hat kein Spiel -> w89
	
.w65:					;------------------------
	test	al,8
	jz	.w70
	xor	al,8
	out	dx,al
	call	.tout
.w70:
	or	al,1
	xor	al,8
	out	dx,al
	call	.tout
	loop	.w65
	
.w75:	
	test	bl,00100000b	;ist Z jetzt nach unten?
	jz	.w89			;nein
	
	mov	ecx,0			;ja - Z war nach oben und ist jetzt nach unten
	and	ah,11001111b
	or	ah,00100000b	;richtung aktuallisieren
	mov	cl,[Spielz]
	cmp	cl,0
	jz	.w89			;Z hat kein Spiel -> w89
	
.w80:					;------------------------
	test	al,8
	jz	.w85
	xor	al,8
	out	dx,al
	call	.tout
.w85:
	and	al,11111110b
	xor	al,8
	out	dx,al
	call	.tout
	loop	.w80			;------------------------	
	
.w89:
	mov	[.richtung],ah
	mov	[.save],al
.w90:
	mov	bl,[Bewegung]
	mov	al,[.save]
	;-------------------
	cmp	bl,1			;-X nach rechts
	jnz	.a2

	inc	dword[X]
	test	al,2
	jz	.b			;wenn bit 2=0 -> b
	xor	al,2
	out	dx,al
	call	.tout
.b:
	xor	al,2
	or	al,1
	jmp	.ende

.a2:	;-------------------
	cmp	bl,2			;+X nach links
	jnz	.a3

	dec	dword[X]
	test	al,2
	jz	.b1			;wenn bit 2=0 -> b
	xor	al,2
	out	dx,al
	call	.tout
.b1:
	xor	al,2
	and	al,11111110b
	jmp	.ende

.a3:	;-------------------
	cmp	bl,4			;Y nach hinten
	jnz	.a4

	inc	dword[Y]
	test	al,4
	jnz	.b2
	xor	al,4
	out	dx,al
	call	.tout
.b2:
	xor	al,4
	or	al,1
	jmp	.ende

.a4:	;-------------------
	cmp	bl,5			;X nach rechts	Y nach hinten
	jnz	.a5

	inc	dword[X]
	inc	dword[Y]
	test	al,2
	jz	.b4
	test	al,4
	jnz	.b3
					;Bit 2=1, Bit 3=0
	xor	al,6
	out	dx,al
	call	.tout
	jmp	.b5
.b3:					;Bit 2=1, Bit 3=1
	xor	al,6
	or	al,1
	out	dx,al
	call	.tout
	xor	al,2
	jmp	.ende
.b4:
	test	al,4
	jnz	.b5
				;Bit 2=0, Bit 3=0
	xor	al,6
	or	al,1
	out	dx,al
	call	.tout
	xor	al,4
	jmp	.ende
.b5:				;Bit 2=0, Bit 3=1
	xor	al,6
	or	al,1
	jmp	.ende


.a5:	;-------------------
	cmp	bl,6		;X nach links	Y nach hinten
	jnz	.a6

	dec	dword[X]
	inc	dword[Y]
	test	al,2
	jz	.b7
	test	al,4
	jnz	.b6
				;Bit 2=1, Bit 3=0
	xor	al,6
	out	dx,al
	call	.tout
	jmp	.b8
.b6:				;Bit 2=1, Bit 3=1
	or	al,1
	xor	al,4
	out	dx,al
	call	.tout
	and	al,11111110b
	xor	al,2
	jmp	.ende
.b7:
	test	al,4
	jnz	.b8
				;Bit 2=0, Bit 3=0
	and	al,11111110b
	xor	al,6
	out	dx,al
	call	.tout
	or	al,1
	xor	al,4
	jmp	.ende
.b8:				;Bit 2=0, Bit 3=1
	and	al,11111110b
	xor	al,2
	out	dx,al
	call	.tout
	or	al,1
	xor	al,4
	jmp	.ende

.a6:	;-------------------
	cmp	bl,8					;Y nach vorne
	jnz	.a7

	dec	dword[Y]
	test	al,4
	jnz	.b9
	xor	al,4
	out	dx,al
	call	.tout
.b9:
	and	al,11111110b
	xor	al,4
	jmp	.ende

.a7:	;-------------------
	cmp	bl,9		;X nach rechts	Y nach vorne
	jnz	.a8

	inc	dword[X]
	dec	dword[Y]
	test	al,2
	jz	.b11
	test	al,4
	jnz	.b10
				;Bit 2=1, Bit 3=0
	xor	al,6
	out	dx,al
	call	.tout
	jmp	.b12
.b10:				;Bit 2=1, Bit 3=1
	xor	al,6
	and	al,11111110b
	out	dx,al
	call	.tout
	xor	al,2
	or	al,1
	jmp	.ende
.b11:
	test	al,4
	jnz	.b12
				;Bit 2=0, Bit 3=0
	xor	al,6
	or	al,1
	out	dx,al
	call	.tout
	xor	al,4
	and	al,11111110b
	jmp	.ende
.b12:				;Bit 2=0, Bit 3=1
	xor	al,2
	or	al,1
	out	dx,al
	call	.tout
	xor	al,4
	and	al,11111110b
	jmp	.ende

.a8:	;-------------------
	cmp	bl,10		;X nach links	Y nach vorne
	jnz	.a9

	dec	dword[X]
	dec	dword[Y]
	test	al,2
	jz	.b14
	test	al,4
	jnz	.b13
				;Bit 2=1, Bit 3=0
	xor	al,6
	out	dx,al
	call	.tout
	jmp	.b15
.b13:				;Bit 2=1, Bit 3=1
	xor	al,6
	and	al,11111110b
	out	dx,al
	call	.tout
	xor	al,2
	jmp	.ende
.b14:
	test	al,4
	jnz	.b15
				;Bit 2=0, Bit 3=0
	xor	al,6
	and	al,11111110b
	out	dx,al
	call	.tout
	xor	al,4
	jmp	.ende
.b15:				;Bit 2=0, Bit 3=1
	xor	al,6
	and	al,11111110b
	jmp	.ende

.a9:	;-------------------
	cmp	bl,16								;Z nach oben
	jnz	.a10

	inc	dword[Z]
	test	al,8
	jz	.b16
	xor	al,8
	out	dx,al
	call	.tout
.b16:
	or	al,1
	xor	al,8
	jmp	.ende

.a10:	;-------------------
	cmp	bl,17		;X nach rechts				Z nach oben
	jnz	.a11

	inc	dword[X]
	inc	dword[Z]
	test	al,2
	jz	.b18
	test	al,8
	jnz	.b17
				;Bit 2=1, Bit 4=0
	xor	al,10
	or	al,1
	out	dx,al
	call	.tout
	xor	al,2
	jmp	.ende
.b17:				;Bit 2=1, Bit 4=1
	xor	al,10
	out	dx,al
	call	.tout
	jmp	.b19
.b18:
	test	al,8
	jnz	.b20
.b19:				;Bit 2=0, Bit 4=0
	xor	al,10
	or	al,1
	jmp	.ende
.b20:				;Bit 2=0, Bit 4=1
	xor	al,10
	or	al,1
	out	dx,al
	call	.tout
	xor	al,8
	jmp	.ende

.a11:	;-------------------
	cmp	bl,18		;X nach links				Z nach oben
	jnz	.a12

	dec	dword[X]
	inc	dword[Z]
	test	al,2
	jz	.b22
	test	al,8
	jnz	.b21
				;Bit 2=1, Bit 4=0
	xor	al,10
	or	al,1
	out	dx,al
	call	.tout
	xor	al,2
	and	al,11111110b
	jmp	.ende
.b21:				;Bit 2=1, Bit 4=1
	xor	al,10
	out	dx,al
	call	.tout
	jmp	.b23
.b22:
	test	al,8
	jnz	.b24
.b23:				;Bit 2=0, Bit 4=0
	xor	al,2
	and	al,11111110b
	out	dx,al
	call	.tout
	xor	al,8
	or	al,1
	jmp	.ende
.b24:				;Bit 2=0, Bit 4=1
	xor	al,10
	and	al,11111110b
	out	dx,al
	call	.tout
	xor	al,8
	or	al,1
	jmp	.ende
.a12:	;-------------------
	cmp	bl,20		;			Y nach hinten	Z nach oben
	jnz	.a13

	inc	dword[Y]
	inc	dword[Z]
	test	al,4
	jnz	.b27
	test	al,8
	jnz	.b26
.b25				;Bit 3=0, Bit 4=0
	xor	al,12
	or	al,1
	out	dx,al
	call	.tout
	xor	al,4
	jmp	.ende
.b26:				;Bit 3=0, Bit 4=1
	xor	al,12
	out	dx,al
	call	.tout
	jmp	.bb27
.b27:
	test	al,8
	jnz	.b28
.bb27:				;Bit 3=1, Bit 4=0
	xor	al,12
	or	al,1
	jmp	.ende
.b28:				;Bit 3=1, Bit 4=1
	xor	al,12
	or	al,1
	out	dx,al
	call	.tout
	xor	al,8
	jmp	.ende
.a13:	;-------------------
	cmp	bl,21		;X nach rechts	Y nach hinten	Z nach oben
	jz	.d1
	jmp	.a14
.d1:
	inc	dword[X]
	inc	dword[Y]
	inc	dword[Z]
	test	al,2
	jnz	.b33
	test	al,4
	jnz	.b30
	test	al,8
	jnz	.b29
				;Bit 2=0, Bit 3=0, Bit 4=0
	xor	al,14
	or	al,1
	out	dx,al
	call	.tout
	xor	al,4
	jmp	.ende
.b29:				;Bit 2=0, Bit 3=0, Bit 4=1
	xor	al,14
	or	al,1
	out	dx,al
	call	.tout
	xor	al,12
	jmp	.ende
.b30:
	test	al,8
	jnz	.b32
.b31:				;Bit 2=0, Bit 3=1, Bit 4=0
	xor	al,14
	or	al,1
	jmp	.ende
.b32:				;Bit 2=0, Bit 3=1, Bit 4=1
	xor	al,14
	or	al,1
	out	dx,al
	call	.tout
	xor	al,8
	jmp	.ende
.b33:
	test	al,4
	jnz	.b35
	test	al,8
	jnz	.b34
				;Bit 2=1, Bit 3=0, Bit 4=0
	xor	al,14
	or	al,1
	out	dx,al
	call	.tout
	xor	al,6
	jmp	.ende
.b34:				;Bit 2=1, Bit 3=0, Bit 4=1
	xor	al,14
	out	dx,al
	call	.tout
	jmp	.b31
.b35:
	test	al,8
	jnz	.b36
				;Bit 2=1, Bit 3=1, Bit 4=0
	xor	al,14
	or	al,1
	out	dx,al
	call	.tout
	xor	al,2
	jmp	.ende
.b36:				;Bit 2=1, Bit 3=1, Bit 4=1
	xor	al,14
	or	al,1
	out	dx,al
	call	.tout
	xor	al,10
	jmp	.ende
.a14	;-------------------
	cmp	bl,22		;X nach links	Y nach hinten	Z nach oben
	jz	.d2
	jmp	.a15
.d2:
	dec	dword[X]
	inc	dword[Y]
	inc	dword[Z]
	test	al,2
	jnz	.b41
	test	al,4
	jnz	.b38
	test	al,8
	jnz	.b37
				;Bit 2=0, Bit 3=0, Bit 4=0
	xor	al,6
	and	al,11111110b
	out	dx,al
	call	.tout
	xor	al,12
	or	al,1
	jmp	.ende
.b37:				;Bit 2=0, Bit 3=0, Bit 4=1
	xor	al,14
	and	al,11111110b
	out	dx,al
	call	.tout
	xor	al,12
	or	al,1
	jmp	.ende
.b38:
	test	al,8
	jnz	.b40
.b39:				;Bit 2=0, Bit 3=1, Bit 4=0
	xor	al,2
	and	al,11111110b
	out	dx,al
	call	.tout
	xor	al,12
	or	al,1
	jmp	.ende
.b40:				;Bit 2=0, Bit 3=1, Bit 4=1
	xor	al,10
	and	al,11111110b
	out	dx,al
	call	.tout
	xor	al,12
	or	al,1
	jmp	.ende
.b41:
	test	al,4
	jnz	.b43
	test	al,8
	jnz	.b42
				;Bit 2=1, Bit 3=0, Bit 4=0
	xor	al,6
	out	dx,al
	call	.tout
	jmp	.b39
.b42:				;Bit 2=1, Bit 3=0, Bit 4=1
	xor	al,14
	out	dx,al
	call	.tout
	jmp	.b39
.b43:
	test	al,8
	jnz	.b44
				;Bit 2=1, Bit 3=1, Bit 4=0
	xor	al,14
	or	al,1
	out	dx,al
	call	.tout
	xor	al,2
	and	al,11111110b
	jmp	.ende
.b44:				;Bit 2=1, Bit 3=1, Bit 4=1
	xor	al,10
	out	dx,al
	call	.tout
	jmp	.b39

.a15:	;-------------------
	cmp	bl,24		;			Y nach vorne	Z nach oben
	jnz	.a16

	dec	dword[Y]
	inc	dword[Z]
	test	al,4
	jz	.b47
	test	al,8
	jnz	.b46
.b45:				;Bit 3=1, Bit 4=0
	xor	al,4
	and	al,11111110b
	out	dx,al
	call	.tout
	xor	al,8
	or	al,1
	jmp	.ende
.b46:				;Bit 3=1, Bit 4=1
	xor	al,12
	and	al,11111110b
	out	dx,al
	call	.tout
	xor	al,8
	or	al,1
	jmp	.ende
.b47:
	test	al,8
	jnz	.b48
				;Bit 3=0, Bit 4=0
	xor	al,12
	or	al,1
	out	dx,al
	call	.tout
	xor	al,4
	and	al,11111110b
	jmp	.ende
.b48:				;Bit 3=0, Bit 4=1
	xor	al,12
	out	dx,al
	call	.tout
	jmp	.b45

.a16:	;-------------------
	cmp	bl,25		;X nach rechts	Y nach vorne	Z nach oben
	jz	.d3
	jmp	.a17
.d3:
	inc	dword[X]
	dec	dword[Y]
	inc	dword[Z]
	test	al,2
	jnz	.b54
	test	al,4
	jnz	.b50
	test	al,8
	jnz	.b49
				;Bit 2=0, Bit 3=0, Bit 4=0
	xor	al,14
	or	al,1
	out	dx,al
	call	.tout
	xor	al,8
	and	al,11111110b
	jmp	.ende
.b49:				;Bit 2=0, Bit 3=0, Bit 4=1
	xor	al,12
	out	dx,al
	call	.tout
	jmp	.b51
.b50:
	test	al,8
	jnz	.b52
.b51:				;Bit 2=0, Bit 3=1, Bit 4=0
	xor	al,4
	and	al,11111110b
	out	dx,al
	call	.tout
	xor	al,10
	or	al,1
	jmp	.ende
.b52:				;Bit 2=0, Bit 3=1, Bit 4=1
	xor	al,12
	and	al,11111110b
	out	dx,al
	call	.tout
	xor	al,10
	or	al,1
	jmp	.ende
.b54:
	test	al,4
	jnz	.b56
	test	al,8
	jnz	.b55
				;Bit 2=1, Bit 3=0, Bit 4=0
	xor	al,6
	out	dx,al
	call	.tout
	jmp	.b51
.b55:				;Bit 2=1, Bit 3=0, Bit 4=1
	xor	al,14
	out	dx,al
	call	.tout
	jmp	.b51
.b56:
	test	al,8
	jnz	.b57
				;Bit 2=1, Bit 3=1, Bit 4=0
	xor	al,6
	and	al,11111110b
	out	dx,al
	call	.tout
	xor	al,10
	or	al,1
	jmp	.ende
.b57:				;Bit 2=1, Bit 3=1, Bit 4=1
	xor	al,14
	and	al,11111110b
	out	dx,al
	call	.tout
	xor	al,10
	or	al,1
	jmp	.ende

.a17:	;-------------------
	cmp	bl,26		;X nach links	Y nach vorne	Z nach oben
	jz	.d4
	jmp	.a18
.d4:
	dec	dword[X]
	dec	dword[Y]
	inc	dword[Z]
	test	al,2
	jnz	.b62
	test	al,4
	jnz	.b59
	test	al,8
	jnz	.b58
				;Bit 2=0, Bit 3=0, Bit 4=0
	xor	al,12
	or	al,1
	out	dx,al
	call	.tout
	xor	al,6
	and	al,11111110b
	jmp	.ende
.b58:				;Bit 2=0, Bit 3=0, Bit 4=1
	xor	al,12
	out	dx,al
	call	.tout
	jmp	.b60
.b59:
	test	al,8
	jnz	.b61
.b60:				;Bit 2=0, Bit 3=1, Bit 4=0
	xor	al,8
	or	al,1
	out	dx,al
	call	.tout
	xor	al,6
	and	al,11111110b
	jmp	.ende
.b61:				;Bit 2=0, Bit 3=1, Bit 4=1
	xor	al,14
	and	al,11111110b
	out	dx,al
	call	.tout
	xor	al,8
	or	al,1
	jmp	.ende
.b62:
	test	al,4
	jnz	.b64
	test	al,8
	jnz	.b63
				;Bit 2=1, Bit 3=0, Bit 4=0
	xor	al,14
	or	al,1
	out	dx,al
	call	.tout
	xor	al,6
	and	al,11111110b
	jmp	.ende
.b63:				;Bit 2=1, Bit 3=0, Bit 4=1
	xor	al,14
	out	dx,al
	call	.tout
	jmp	.b60
.b64:
	test	al,8
	jnz	.b65
				;Bit 2=1, Bit 3=1, Bit 4=0
	xor	al,10
	or	al,1
	out	dx,al
	call	.tout
	xor	al,6
	and	al,11111110b
	jmp	.ende
.b65:				;Bit 2=1, Bit 3=1, Bit 4=1
	xor	al,10
	out	dx,al
	call	.tout
	jmp	.b60

.a18:	;-------------------
	cmp	bl,32		;						Z nach unten
	jnz	.a19

	dec	dword[Z]
	test	al,8
	jz	.b66
	xor	al,8
	out	dx,al
	call	.tout
.b66:
	and	al,11111110b
	xor	al,8
	jmp	.ende

.a19:	;-------------------
	cmp	bl,33		;X nach rechts				Z nach unten
	jnz	.a20

	inc	dword[X]
	dec	dword[Z]
	test	al,2
	jz	.b68
	test	al,8
	jnz	.b67
				;Bit 2=1, Bit 4=0
	xor	al,10
	and	al,11111110b
	out	dx,al
	call	.tout
	xor	al,2
	or	al,1
	jmp	.ende
.b67:				;Bit 2=1, Bit 4=1
	xor	al,10
	out	dx,al
	call	.tout
	jmp	.b69
.b68:
	test	al,8
	jnz	.b70
.b69:				;Bit 2=0, Bit 4=0
	xor	al,2
	or	al,1
	out	dx,al
	call	.tout
	xor	al,8
	and	al,11111110b
	jmp	.ende
.b70:				;Bit 2=0, Bit 4=1
	xor	al,10
	or	al,1
	out	dx,al
	call	.tout
	xor	al,8
	and	al,11111110b
	jmp	.ende

.a20:	;-------------------
	cmp	bl,34		;X nach links				Z nach unten
	jnz	.a21

	dec	dword[X]
	dec	dword[Z]
	test	al,2
	jz	.b72
	test	al,8
	jnz	.b71
				;Bit 2=1, Bit 4=0
	xor	al,10
	and	al,11111110b
	out	dx,al
	call	.tout
	xor	al,2
	jmp	.ende
.b71:				;Bit 2=1, Bit 4=1
	xor	al,10
	out	dx,al
	call	.tout
	jmp	.b73
.b72:
	test	al,8
	jnz	.b74
.b73:				;Bit 2=0, Bit 4=0
	xor	al,10
	and	al,11111110b
	jmp	.ende
.b74:				;Bit 2=0, Bit 4=1
	xor	al,10
	and	al,11111110b
	out	dx,al
	call	.tout
	xor	al,8
	jmp	.ende

.a21:	;-------------------
	cmp	bl,36		;			Y nach hinten	Z nach unten
	jnz	.a22

	inc	dword[Y]
	dec	dword[Z]
	test	al,4
	jz	.b77
	test	al,8
	jnz	.b76
.b75:				;Bit 3=1, Bit 4=0
	xor	al,4
	or	al,1
	out	dx,al
	call	.tout
	xor	al,8
	and	al,11111110b
	jmp	.ende
.b76:				;Bit 3=1, Bit 4=1
	xor	al,12
	or	al,1
	out	dx,al
	call	.tout
	xor	al,8
	and	al,11111110b
	jmp	.ende
.b77:
	test	al,8
	jnz	.b78
				;Bit 3=0, Bit 4=0
	xor	al,12
	and	al,11111110b
	out	dx,al
	call	.tout
	xor	al,4
	or	al,1
	jmp	.ende
.b78:				;Bit 3=0, Bit 4=1
	xor	al,12
	out	dx,al
	call	.tout
	jmp	.b75

.a22:	;-------------------
	cmp	bl,37		;X nach rechts	Y nach hinten	Z nach unten
	jz	.d5
	jmp	.a23
.d5:
	inc	dword[X]
	inc	dword[Y]
	dec	dword[Z]
	test	al,2
	jnz	.b83
	test	al,4
	jnz	.b80
	test	al,8
	jnz	.b79
				;Bit 2=0, Bit 3=0, Bit 4=0
	xor	al,12
	and	al,11111110b
	out	dx,al
	call	.tout
	xor	al,6
	or	al,1
	jmp	.ende
.b79:				;Bit 2=0, Bit 3=0, Bit 4=1
	xor	al,12
	out	dx,al
	call	.tout
	jmp	.b81
.b80:
	test	al,8
	jnz	.b82
.b81:				;Bit 2=0, Bit 3=1, Bit 4=0
	xor	al,8
	and	al,11111110b
	out	dx,al
	call	.tout
	xor	al,6
	or	al,1
	jmp	.ende
.b82:				;Bit 2=0, Bit 3=1, Bit 4=1
	xor	al,14
	or	al,1
	out	dx,al
	call	.tout
	xor	al,8
	and	al,11111110b
	jmp	.ende
.b83:
	test	al,4
	jnz	.b85
	test	al,8
	jnz	.b84
				;Bit 2=1, Bit 3=0, Bit 4=0
	xor	al,14
	and	al,11111110b
	out	dx,al
	call	.tout
	xor	al,6
	or	al,1
	jmp	.ende
.b84:				;Bit 2=1, Bit 3=0, Bit 4=1
	xor	al,14
	out	dx,al
	call	.tout
	jmp	.b81
.b85:
	test	al,8
	jnz	.b86
				;Bit 2=1, Bit 3=1, Bit 4=0
	xor	al,10
	and	al,11111110b
	out	dx,al
	call	.tout
	xor	al,6
	or	al,1
	jmp	.ende
.b86:				;Bit 2=1, Bit 3=1, Bit 4=1
	xor	al,10
	out	dx,al
	call	.tout
	jmp	.b81

.a23:	;-------------------
	cmp	bl,38		;X nach links	Y nach hinten	Z nach unten
	jz	.d6
	jmp	.a24
.d6:

	dec	dword[X]
	inc	dword[Y]
	dec	dword[Z]
	test	al,2
	jnz	.b91
	test	al,4
	jnz	.b88
	test	al,8
	jnz	.b87
				;Bit 2=0, Bit 3=0, Bit 4=0
	xor	al,14
	and	al,11111110b
	out	dx,al
	call	.tout
	xor	al,4
	or	al,1
	jmp	.ende
.b87:				;Bit 2=0, Bit 3=0, Bit 4=1
	xor	al,12
	out	dx,al
	call	.tout
	jmp	.b89
.b88:
	test	al,8
	jnz	.b90
.b89:				;Bit 2=0, Bit 3=1, Bit 4=0
	xor	al,4
	or	al,1
	out	dx,al
	call	.tout
	xor	al,10
	and	al,11111110b
	jmp	.ende
.b90:				;Bit 2=0, Bit 3=1, Bit 4=1
	xor	al,12
	or	al,1
	out	dx,al
	call	.tout
	xor	al,10
	and	al,11111110b
	jmp	.ende
.b91:
	test	al,4
	jnz	.b93
	test	al,8
	jnz	.b92
				;Bit 2=1, Bit 3=0, Bit 4=0
	xor	al,6
	out	dx,al
	call	.tout
	jmp	.b89
.b92:				;Bit 2=1, Bit 3=0, Bit 4=1
	xor	al,14
	out	dx,al
	call	.tout
	jmp	.b89
.b93:
	test	al,8
	jnz	.b94
				;Bit 2=1, Bit 3=1, Bit 4=0
	xor	al,6
	or	al,1
	out	dx,al
	call	.tout
	xor	al,10
	and	al,11111110b
	jmp	.ende
.b94:				;Bit 2=1, Bit 3=1, Bit 4=1
	xor	al,14
	or	al,1
	out	dx,al
	call	.tout
	xor	al,10
	and	al,11111110b
	jmp	.ende

.a24:	;-------------------
	cmp	bl,40		;			Y nach vorne	Z nach unten
	jnz	.a25

	dec	dword[Y]
	dec	dword[Z]
	test	al,4
	jz	.b97
	test	al,8
	jnz	.b96
.b95				;Bit 3=1, Bit 4=0
	xor	al,12
	and	al,11111110b
	jmp	.ende
.b96:				;Bit 3=1, Bit 4=1
	xor	al,12
	and	al,11111110b
	out	dx,al
	call	.tout
	xor	al,8
	jmp	.ende
.b97:
	test	al,8
	jnz	.b98
				;Bit 3=0, Bit 4=0
	xor	al,12
	and	al,11111110b
	out	dx,al
	call	.tout
	xor	al,4
	jmp	.ende
.b98:				;Bit 3=0, Bit 4=1
	xor	al,12
	out	dx,al
	call	.tout
	jmp	.b95

.a25:	;-------------------
	cmp	bl,41		;X nach rechts	Y nach vorne	Z nach unten
	jz	.d7
	jmp	.a26
.d7:
	inc	dword[X]
	dec	dword[Y]
	dec	dword[Z]
	test	al,2
	jnz	.c5
	test	al,4
	jnz	.c2
	test	al,8
	jnz	.c1
				;Bit 2=0, Bit 3=0, Bit 4=0
	xor	al,6
	or	al,1
	out	dx,al
	call	.tout
	xor	al,12
	and	al,11111110b
	jmp	.ende
.c1:				;Bit 2=0, Bit 3=0, Bit 4=1
	xor	al,14
	or	al,1
	out	dx,al
	call	.tout
	xor	al,12
	and	al,11111110b
	jmp	.ende
.c2:
	test	al,8
	jnz	.c4
.c3:				;Bit 2=0, Bit 3=1, Bit 4=0
	xor	al,2
	or	al,1
	out	dx,al
	call	.tout
	xor	al,12
	and	al,11111110b
	jmp	.ende
.c4:				;Bit 2=0, Bit 3=1, Bit 4=1
	xor	al,10
	or	al,1
	out	dx,al
	call	.tout
	xor	al,12
	and	al,11111110b
	jmp	.ende
.c5:
	test	al,4
	jnz	.c7
	test	al,8
	jnz	.c6
				;Bit 2=1, Bit 3=0, Bit 4=0
	xor	al,6
	out	dx,al
	call	.tout
	jmp	.c3
.c6:				;Bit 2=1, Bit 3=0, Bit 4=1
	xor	al,14
	out	dx,al
	call	.tout
	jmp	.c3
.c7:
	test	al,8
	jnz	.c8
				;Bit 2=1, Bit 3=1, Bit 4=0
	xor	al,14
	and	al,11111110b
	out	dx,al
	call	.tout
	xor	al,2
	or	al,1
	jmp	.ende
.c8:				;Bit 2=1, Bit 3=1, Bit 4=1
	xor	al,10
	out	dx,al
	call	.tout
	jmp	.c3

.a26:	;-------------------
	cmp	bl,42		;X nach links	Y nach vorne	Z nach unten
	jz	.d8
	jmp	.ende2
.d8:
	dec	dword[X]
	dec	dword[Y]
	dec	dword[Z]
	test	al,2
	jnz	.c13
	test	al,4
	jnz	.c10
	test	al,8
	jnz	.c9
				;Bit 2=0, Bit 3=0, Bit 4=0
	xor	al,14
	and	al,11111110b
	out	dx,al
	call	.tout
	xor	al,4
	jmp	.ende
.c9:				;Bit 2=0, Bit 3=0, Bit 4=1
	xor	al,14
	and	al,11111110b
	out	dx,al
	call	.tout
	xor	al,12
	jmp	.ende
.c10:
	test	al,8
	jnz	.c12
.c11:				;Bit 2=0, Bit 3=1, Bit 4=0
	xor	al,14
	and	al,11111110b
	jmp	.ende
.c12:				;Bit 2=0, Bit 3=1, Bit 4=1
	xor	al,14
	and	al,11111110b
	out	dx,al
	call	.tout
	xor	al,8
	jmp	.ende
.c13:
	test	al,4
	jnz	.c15
	test	al,8
	jnz	.c14
				;Bit 2=1, Bit 3=0, Bit 4=0
	xor	al,14
	and	al,11111110b
	out	dx,al
	call	.tout
	xor	al,6
	jmp	.ende
.c14:				;Bit 2=1, Bit 3=0, Bit 4=1
	xor	al,14
	out	dx,al
	call	.tout
	xor	al,14
	and	al,11111110b
	jmp	.ende
.c15:
	test	al,8
	jnz	.c16
				;Bit 2=1, Bit 3=1, Bit 4=0
	xor	al,14
	and	al,11111110b
	out	dx,al
	call	.tout
	xor	al,2
	jmp	.ende
.c16:				;Bit 2=1, Bit 3=1, Bit 4=1
	xor	al,14
	and	al,11111110b
	out	dx,al
	call	.tout
	xor	al,10
	jmp	.c11


.ende:
	mov	[.save],al
	out	dx,al
	mov	ecx,[Delay]
	cmp	ecx,500
	jae	.ende1
	mov	dword[Delay],500
	mov	ecx,500
.ende1:
	in	al,$40
	loop	.ende1
.ende2:
	in	al,0x60		;letzte losgelassene Taste war
	cmp	al,176		;B
	jnz	.ende3
	mov	eax,11
	jmp	Ende
.ende3:	
	popad
	ret


.tout:	;-------------------
	pushad
	mov	ecx,500		;Ausgabeverzgerung in s bzw.  1MHz-Teiler.
.tout1:
	in	al,$40
	loop	.tout1
	popad
	ret

